Update Red Hat Copyright Notices
[nbdkit.git] / tests / test-retry-size.sh
blob47b592cd667fec99952633578fd50121154294d0
1 #!/usr/bin/env bash
2 # nbdkit
3 # Copyright Red Hat
5 # Redistribution and use in source and binary forms, with or without
6 # modification, are permitted provided that the following conditions are
7 # met:
9 # * Redistributions of source code must retain the above copyright
10 # notice, this list of conditions and the following disclaimer.
12 # * Redistributions in binary form must reproduce the above copyright
13 # notice, this list of conditions and the following disclaimer in the
14 # documentation and/or other materials provided with the distribution.
16 # * Neither the name of Red Hat nor the names of its contributors may be
17 # used to endorse or promote products derived from this software without
18 # specific prior written permission.
20 # THIS SOFTWARE IS PROVIDED BY RED HAT AND CONTRIBUTORS ''AS IS'' AND
21 # ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
22 # THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
23 # PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL RED HAT OR
24 # CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
25 # SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
26 # LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
27 # USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
28 # ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
29 # OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
30 # OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
31 # SUCH DAMAGE.
33 source ./functions.sh
34 set -e
35 set -x
37 fail=0
39 requires_plugin sh
40 requires_nbdsh_uri
41 requires dd iflag=count_bytes </dev/null
43 files="retry-size-open-count retry-size-fail"
44 rm -f $files
45 cleanup_fn rm -f $files
47 touch retry-size-open-count
48 start_t=$SECONDS
50 # Create a custom plugin which will test retrying.
51 st=0
52 nbdkit -v -U - \
53 sh - \
54 --filter=retry retry-delay=1 \
55 --run 'nbdsh -u "$uri" \
56 -c "h.pread(512, 0)" -c "h.cache(512, 512)"' <<'EOF' || st=$?
57 #!/usr/bin/env bash
58 case "$1" in
59 open)
60 # Count how many times the connection is (re-)opened.
61 read i < retry-size-open-count
62 echo $((i+1)) > retry-size-open-count
64 get_size)
65 # Temporarily report a smaller size
66 read i < retry-size-open-count
67 if [ $i = 2 ]; then
68 echo 512
69 else
70 echo 1024
73 can_cache)
74 echo native
76 pread | cache)
77 # Fail first open unconditionally
78 # On second open, ensure nbdkit obeys smaller bound
79 # On third open, allow read to succeed
80 read i < retry-size-open-count
81 case $i in
82 1) echo "EIO too soon to read" >&2
83 exit 1 ;;
84 2) if [ $(( $3 + $4 )) -gt 512 ]; then
85 touch retry-size-fail
86 fi ;;
87 esac
88 if [ $1 = pread ]; then
89 dd if=/dev/zero count=$3 iflag=count_bytes
92 *) exit 2 ;;
93 esac
94 EOF
96 # In this test we should see the following:
97 # open reports size 1024
98 # first pread FAILS
99 # retry and wait 1 seconds
100 # open reports size 512
101 # first pread succeeds
102 # second pread FAILS without calling into pread
103 # retry and wait 1 seconds
104 # open reports size 1024
105 # second pread succeeds
107 # The minimum time for the test should be 1+1 = 2 seconds.
108 end_t=$SECONDS
109 if [ $((end_t - start_t)) -lt 2 ]; then
110 echo "$0: test ran too quickly"
111 fail=1
114 # Check the handle was opened 3 times (first open + reopens).
115 read open_count < retry-size-open-count
116 if [ $open_count -ne 3 ]; then
117 echo "$0: open-count ($open_count) != 3"
118 fail=1
121 # Check that nbdkit checked bounds
122 if [ -e retry-size-fail ]; then
123 echo "$0: nbdkit read past EOF"
124 fail=1
127 exit $fail